package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.InstrumentPanelGroupDTO;
import com.syc.slm.slmbi.entity.InstrumentPanelGroup;
import com.syc.slm.slmbi.vo.InstrumentPanelGroupVo;
import com.syc.slm.slmbi.vo.PanelTreeNodeVo;
import lombok.NonNull;

import java.util.List;

/**
 * slm-bi
 * 仪表板
 *
 * @author : lin
 * @date : 2021-03-25 15:10
 **/
public interface InstrumentPanelGroupService extends IService<InstrumentPanelGroup> {

    /**
     * 查询仪表板分组
     * @return
     */
    List<InstrumentPanelGroupVo> selectGroupList();

    /**
     * 删除仪表板分组
     * @param groupId
     * @return
     */
    String delGroup(@NonNull String groupId);

    /**
     * 修改仪表板分组
     * @param group
     * @return
     */
    String updateGroup(InstrumentPanelGroupDTO group);

    /**
     * 保存仪表板分组
     * @param group
     * @return
     */
    String saveGroup(InstrumentPanelGroupDTO group);

    /**
     * 加载仪表板树
     * @param name
     * @return
     */
    List<PanelTreeNodeVo> loadTrees(String name);

    /**
     * 查询下一节点分组
     * @param groupId
     * @param name
     * @return
     */
    List<PanelTreeNodeVo> children(String groupId, String name);
}
