package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.SaveInstrumentPanelDTO;
import com.syc.slm.slmbi.dto.QueryInstrumentPanelDTO;
import com.syc.slm.slmbi.entity.InstrumentPanel;
import com.syc.slm.slmbi.vo.InstrumentPanelVo;

import java.util.List;

/**
 * slm-bi
 * 仪表板
 *
 * @author : lin
 * @date : 2021-03-25 16:17
 **/
public interface InstrumentPanelService extends IService<InstrumentPanel> {
    /**
     * 仪表板列表
     *
     * @param where
     * @return
     */
    IPage<InstrumentPanelVo> selectInstrumentPanelList(QueryInstrumentPanelDTO where);

    /**
     * 保存仪表板
     *
     * @param panel
     * @return
     */
    String savePanel(SaveInstrumentPanelDTO panel);

    /**
     * 批量推送
     *
     * @param ids
     * @return
     */
    Boolean batchPublish(List<String> ids);

    /**
     * 删除仪表板
     *
     * @param id
     * @return
     */
    String delPanel(String id);

    /**
     * 另存为
     *
     * @param instrumentPanelDTO
     * @return
     */
    String saveAsPanel(SaveInstrumentPanelDTO instrumentPanelDTO);

    /**
     * 是否显示恢复按钮
     *
     * @param id
     * @return
     */
    Boolean showRecoveryBtn(String id);

    /**
     * 恢复按钮操作
     *
     * @param id
     * @return
     */
    String recoveryPanel(String id);

    /**
     * 下线
     *
     * @param id
     * @return
     */
    String offline(String id);
}
